package com.sijobe.console;

/**
 *
 * @author simo_415
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
public interface ConsoleListener {
   /**
    * Implementation of this method allows input to be processed when input is
    * submitted to the user
    *
    * @param input - The input string from the user
    * @returns true if message should be sent and false if message should not be sent
    */
   public boolean processInput(String input);

   /**
    * Implementation of this method allows output to be processed when output is
    * generated by Minecraft or another mod
    *
    * @param output - The output string from Minecraft
    */
   public void processOutput(String output);
}
